]> git.sesse.net Git - backup.sh/blob - backup.sh
Unify logging a bit.
[backup.sh] / backup.sh
1 #!/bin/bash
2 # backup.sh
3
4 # Backup up Unix-like computers
5
6 # itk@samfundet.no
7 #
8 # This script was first checked into RCS in 2000, and has since backed up a few
9 # servers almost every day, whenever not broken.
10
11 # It's a bit peculiar, but quite effective. The following is worth keeping in
12 # mind when hacking:
13 #
14 # Because of the way we run this script from cron, informational logging goes
15 # to stderr and warnings and errors to stdout. This way, we get mail whenever
16 # stuff fails, and other output is redirected to the log file.
17
18 # The script is halfway Norwegian and halfway English. Newer modifications are
19 # in English, we should probably stick to that.
20
21 # The computer to backup.
22 computer=$1
23
24 # Configuration
25 LOCKFILE=/home/backup/backuprun.lockfile.$computer
26 confdir=/home/backup/conf/              # Configuration files
27 storagedir=/backup                      # Where we keep backups
28 maxnumfull=3                            # Number of full backups
29 daysbetweenfull=30                      # Days between full backups
30 daysbetweenfullforfixed=32              # Days between full backups for machines with fixed
31                                         # full-backup date (in case the fixed day gets missed)
32 DAY_OF_MONTH=`date "+%d" | sed s/^0//`  # from 1 to 31
33 DATE=`date "+%Y%m%d%H%M"`               #format: touch
34 DATEs=`date "+%Y-%m-%d %H:%M"`          #format: tar
35
36 # Exclude-pattern
37 exclude=$confdir/exclude
38 [ ! -f $exclude ] && printf "tmp\ncore\n" > $exclude
39
40 if [ -z "$computer" ]; then
41         echo "Usage: $0 COMPUTER"
42         exit 1
43 fi
44
45 # Die more or less gracefully (at least notify user)
46 die() {
47         echo `date`": Something nasty happened."
48         rm $LOCKFILE
49         exit 1
50 }
51 diemsg() {
52         echo `date`": $computer: $@"
53         die
54 }
55
56 # Trap C-c and kill
57 trap die SIGINT SIGTERM
58
59 # Don't start if we're already running
60 if [ -e $LOCKFILE ]; then
61         echo `date`": $LOCKFILE exists for pid `cat $LOCKFILE`, exiting."
62         echo `date`": $LOCKFILE exists for pid `cat $LOCKFILE`, exiting." >&2
63         exit 1
64 fi;
65 touch $LOCKFILE
66 echo $$ > $LOCKFILE
67
68 echo `date`": Backup run starting" >&2
69
70 umask 027
71
72
73 backup()
74 {
75         echo -n `date` >&2
76         printf " $computer: $computer:$filesystem $backuplevel backup\n" >&2
77
78         SNARFILE="${storagedir}/${computer}/${sfilesystem}/.incremental.snar"
79         incrementalsnar="/root/.backup/${sfilesystem}.snar"
80         if [ "$backuplevel" = "daglig" ]
81         then
82                 # If incremental backup, we need to copy the incremental status to $computer.
83                 # If it does not exist, whine a bit and then run date-based instead.
84                 if [ -s "$SNARFILE" ]; then
85                         if ! scp $SNARFILE root@$computer:$incrementalsnar; then
86                                 diemsg "Could not copy .incremental.snar to $computer"
87                         fi
88                         lastcmd="--listed-incremental=$incrementalsnar --no-check-device"
89                 else
90                         echo `date`" $computer: Missing incremental.snar for $filesystem, doing date-based backup instead until next full backup" >&2
91                         incrementalsnar=""
92                         lastd=`cat ../.date`
93                         lastcmd="--newer='$lastd'"
94                 fi
95         else
96                 lastcmd="--listed-incremental=$incrementalsnar"
97         fi
98
99         # We try to run tar on the remote computer
100         #    c create archive
101         #    C change to directory first
102         #    . where to start taring (see C)
103         #    $lastcmd only files newer than this
104         #    --one-file-system don't traverse file systems
105         #    --use-compress-program compress it using gzip or pigz
106         #    --exclude-from file to get exclusion pattern from
107         #    Pipe the stuff over ssh to ourselves, run pee to cat the contents to a
108         #    file and build a file list, respectivly.  
109         TARFILE=$DATE.tmp
110         TARCMD="ssh root@$computer \"nice -n 19 ionice -c3 tar --one-file-system --use-compress-program $compressor -cf - -C $filesystem . $lastcmd \
111                 --exclude-from=/root/.backup/exclude\" | pee \"cat > $TARFILE\" \"tar tzvf -\""
112         echo `date`" $computer: Running $TARCMD" >&2
113         eval $TARCMD > $DATE.idx
114
115         if [ $? -eq 0 ] && [ -s $TARFILE ]; then
116                 # File is >0 in size and neither cat or tar tzvf failed; we assume it worked.
117
118                 if ! scp root@$computer:$incrementalsnar $SNARFILE.tmp; then
119                         diemsg "Could not copy .incremental.snar from $computer"
120                 fi
121
122                 # Move tar file in place
123                 mv $TARFILE $DATE.tgz
124                 mv $SNARFILE.tmp $SNARFILE
125
126                 # Update timestamp
127                 echo $DATEs > ../.date && touch -t $DATE ../.date
128
129                 # Make a sorted file list as well
130                 sort -k6 < $DATE.idx > $DATE.sdx
131
132                 # Fix permissions
133                 chmod 600 *tgz                      #only for us
134                 chmod 644 *sdx *idx 2>/dev/null     #everyone can read
135
136                 # Let the remote computer know that we ran a successful backup (for nagios)
137                 ssh root@$computer touch $filesystem/.lastbackup
138         else
139                 # Something wrong happened.
140                 rm $TARFILE
141                 diemsg "tar failed or $TARFILE empty. $backuplevel backup of $computer:$filesystem failed and deleted"
142         fi
143 }
144
145 # Check that the target filesystem is mounted (actually check that it's not
146 # the root filesystem)
147 if [ ! -d "$storagedir/$computer" ]; then
148         diemsg "Target filesystem ($storagedir/$computer) does not exist. Aborting"
149 fi
150 rootfilesystem=`df -P /`
151 targetfilesystem=`df -P "$storagedir/$computer"`
152 if [ "$rootfilesystem" == "$targetfilesystem" ]; then
153         diemsg "Target filesystem ($storagedir/$computer) was mounted on /. Aborting"
154 fi
155
156 echo `date`" $computer: Backing up $computer" >&2
157
158 # Try to SSH to the computer without entering a password.
159 if ! `ssh -n -o NumberOfPasswordPrompts=0 root@$computer /bin/true`; then
160         diemsg "Could not use passwordless SSH."
161 fi
162
163 # Check if pigz is available
164 if ssh -n root@$computer "pigz -V 2>/dev/null"; then
165         compressor=pigz
166 else
167         echo `date`" $computer: pigz missing; falling back to gzip."
168         compressor=gzip
169 fi
170
171 # Check dump bit in fstab
172 filesystems=`ssh -n root@$computer "cat /etc/fstab" \
173         | grep -v nfs \
174         | grep -v "^#" \
175         | grep -v "^$" \
176         | awk '{ if ( $(NF-1) != "0" ) print $2}' `
177
178 # Clean up our dir at this client
179 if ! ssh root@$computer "rm -r /root/.backup ; mkdir -m 700 /root/.backup"; then
180         diemsg "Could not create backup staging area at $computer:/root/.backup"
181 fi
182
183 # Try to copy $exclude to $computer
184 if ! scp $exclude root@$computer:/root/.backup/exclude > /dev/null; then
185         diemsg "Could not copy exclude.txt to $computer"
186 fi
187
188 # Try to copy preeexec and postexec if they exist
189 if [ -f $confdir/preexec.$computer ]; then
190         if ! scp $confdir/preexec.$computer  root@$computer:/root/.backup/preexec >&2; then
191                 diemsg "Could not copy preexec.$computer to $computer:/root/.backup/preexec"
192         fi
193 fi
194 if [ -f $confdir/postexec.$computer ]; then
195         if ! scp $confdir/postexec.$computer root@$computer:/root/.backup/postexec >&2; then
196                 diemsg "Could not copy postexec.$computer to $computer:/root/.backup/postexec"
197         fi
198 fi
199
200 # Try to run preexec if it exists
201 if ! ssh root@$computer "[ ! -f /root/.backup/preexec ] || /bin/bash -x /root/.backup/preexec" >&2; then
202         diemsg "Could not run $computer:/root/.backup/preexec"
203 fi
204
205 for filesystem in $filesystems
206 do
207         # Remove / and $ (for Windows) for path names
208         sfilesystem=`echo $filesystem | tr '\/\$' '__'`
209
210         # Prepare storage area
211         mkdir -m 755 -p $storagedir/$computer/$sfilesystem/full 2>/dev/null
212         mkdir -m 755 -p $storagedir/$computer/$sfilesystem/daglig 2>/dev/null
213
214         # Default backuplevel
215         backuplevel=daglig
216
217         if [ ! -f $storagedir/$computer/$sfilesystem/.date ]
218         then
219                 # Take the first full backup of this filesystem on this computer
220                 backuplevel=full
221                 echo $DATEs > $storagedir/$computer/$sfilesystem/.date
222         fi
223
224         # Check if we want a full backup
225         if [ -f $confdir/fastfullbackupdag.$computer.$sfilesystem ]; then
226                 fullbackup_min_for_this_machine=$daysbetweenfullforfixed
227                 if [ "$DAY_OF_MONTH" = "`cat $confdir/fastfullbackupdag.$computer.$sfilesystem`" ]; then
228                         backuplevel=full
229                 fi
230         elif [ -f $confdir/fastfullbackupdag.$computer ]; then
231                 fullbackup_min_for_this_machine=$daysbetweenfullforfixed
232                 if [ "$DAY_OF_MONTH" = "`cat $confdir/fastfullbackupdag.$computer`" ]; then
233                         backuplevel=full
234                 fi
235         else
236                 fullbackup_min_for_this_machine=$daysbetweenfull 
237         fi
238
239         if [ -z "`find $storagedir/$computer/$sfilesystem/full/ -name \*tgz -mtime -$fullbackup_min_for_this_machine`" ]; then
240                 backuplevel=full
241         fi
242
243         # We want to be here
244         cd $storagedir/$computer/$sfilesystem/$backuplevelmsg || die "$storagedir/$computer/$sfilesystem/$backuplevel does not exist"
245
246         # Perform the actual backup
247         backup
248
249         # Check if this box has a custom number of full backups
250         if [ -f $confdir/maksfulle.$computer ] ; then
251                 mf=$((`cat $confdir/maksfulle.$computer`+1))
252         else
253                 mf=$(($maxnumfull+1))
254         fi
255
256         # Delete old full backups
257         for full in `ls -1t $storagedir/$computer/$sfilesystem/full/*tgz | tail -n +$mf`
258         do
259                 prefix=`echo $full | sed "s/\.[^.]*$//"`
260                 echo `date`": $computer:$filesystem Deleting full backup $prefix" >&2
261                 rm $prefix*
262         done
263
264         # Delete incremental backups older than the oldest full backup
265         oldf=`ls -t1 $storagedir/$computer/$sfilesystem/full/*tgz | tail -1`
266         find \
267                 $storagedir/$computer/$sfilesystem/daglig \
268                 -type f \
269                 \! -newer $oldf \
270                 -printf "`date`: $computer: Deleting old incremental backup: %p\n" \
271                 -exec rm {} \; >&2
272 done
273
274 # Try to run postexec if it exist
275 if ! ssh root@$computer "[ ! -f /root/.backup/postexec ] || /bin/bash -x /root/.backup/postexec" >&2; then
276         diemsg "Could not run $computer:/root/.backup/postexec"
277 fi
278
279 # Remove lockfile
280 rm $LOCKFILE